package org.coderu.core.impl.common.types;

import javax.annotation.Nullable;

import org.coderu.common.utils.types.SingleValue;
import org.coderu.core.api.Clazz;
import org.coderu.core.api.Packagge;

import com.google.common.base.Function;

@SuppressWarnings("serial")
public class ClassName extends SingleValue<String> implements Comparable<ClassName>{

    public static final Function<Clazz,ClassName> FROM_CLAZZ = new Function<Clazz, ClassName>() {
        
        @Override
        public ClassName apply(@Nullable Clazz input) {
        
            return new ClassName(input.getValue());
        }
    };
    
    public ClassName(String value) {
        super(value);
    }
    
    public int compareTo(ClassName o) {
        return getValue().compareTo(o.getValue());
    }

    public static Packagge getPackage(final ClassName className){
        final String value = className.getValue();
        final int lastPackagePoint = value.lastIndexOf('.');
        return new Packagge(value.substring(0,lastPackagePoint));
    }
    
    public static ClassName stripInnerClassPostfix(final ClassName className){
        final String value = className.getValue();
        final int lastPackagePoint = value.indexOf('$');
        return lastPackagePoint != -1 ? new ClassName(value.substring(0,lastPackagePoint)) : className;
    }
}
