package org.coderu.core.impl.explorer.parser;

import java.io.File;
import java.util.Collection;

import org.coderu.core.impl.common.types.PackageName;
import org.coderu.core.impl.common.types.PackageWithDependencies;
import org.coderu.core.impl.explorer.parser.impl.DependencyParser;
import org.coderu.core.impl.explorer.parser.impl.PackageFilterFactory;


public final class PackageLoader {

    public static Collection<PackageWithDependencies> load(
            final Collection<File> classpath, 
            final Collection<PackageName> components, 
            final Collection<PackageName> excluded){

        final DependencyParser parser = 
            new DependencyParser(PackageFilterFactory.createFilter(components,excluded));
        
        return parser.analyse(classpath);
    }

    
    private PackageLoader(){}
}
